#include "declare.h"

//initialisation variable soft qui ne peuvent se faire en declaration (global.c)
void init_soft () {
	
	SR3_Inhibit = 1;
	GBA_Escrow = 1;

}

//initialisation du pic en registre interne en fct de l'utilisation
void init_pic () {

	//configurer PORTA RA0  RA5 en input digitale

	PORTA = 0;
	ANSEL = 0;
	TRISA = 0b00111111;

	//configurer PORTC RC0  RC5 en input digital

	PORTC = 0;
	TRISC = 0b00111111;

	//configurer PORTB RB0,RB2,RB3,RB7 Digital output et RB1,RB4,RB5,RB6 digital input
	PORTB = 0;
	ANSELH = 0;

	ANS10 = 1;	//RB1 entre analogique pour mode comparateur
	TRISB = 0b01110010;

	//configurer RC6/TX RC7/RX pour entree/sortie UART 9600 baude 8 bit + 1 bit stop

	SPBRG = 129;		//9600 baude
	BRGH = 1;
	BRG16 = 0;

	SYNC = 0;			//mode asynchrone
	SPEN = 1;			//serial port enable
	TX9 = 0;			//mode 8 bit

	TXEN = 1;			//transmit enabled

	PEIE = 1;			//peripheral interupt enable

	RCIE = 1;			//interupt RX enable
	CREN = 1;			//enable reception

	//configurer Timer0

	T0CS = 0;			//clock source par Fosc/4
	PSA = 0;			//Prescaler pour Timer0

	PS2 = 1;			//prescaler 000 = 1:2
	PS1 = 1;
	PS0 = 1;

	T0IE = 1;			//autoris Timer0 interupt

	
	//configurartion RB1 en entre comparateur

	C1ON = 1;			//Enable C1
	
	C1CH1 = 1;			//Input selection C12IN3- = RB1
	C1CH0 = 1;
	
	C1R = 1;			//C1 Vref out
	C1RSEL = 1;			//C1 Vref

	VRSS = 0;			//Vdd,Vss
	VROE = 0;			//not connected Vref to RA2
	VREN = 1;			//enable Vref
	VR3 = 1;			// Vref = 	
	VR2 = 1;
	VR1 = 0;
	VR0 = 0;
	VRR = 0;			//high range

	C1OE = 0;			//output internal only
	C1POL = 0;			//logic inverted

}