#include "declare.h"

void test () {
	eeprom_write(0,0);
}

void interrupt my_isr (void) {
unsigned char Rx;
unsigned char buffer_timer;
unsigned char y;
	
	//interupt du comparateur C1
	if (C1IE && C1IF) {

		C1IF = 0;
		C1IE = 0;
	
		y = CM1CON0;

		if ((save_flag_credit == 1) || (Cmd_MK2 == 1)) {

			Cmd_MK2 = 0;

			Cmd_D_Plaq = 1;
			eeprom_write(0,credit_en_cent_not_yet_read / 256);		//adress, value
			eeprom_write(1,credit_en_cent_not_yet_read % 256);		//adress, value
			eeprom_write(2,nbr_jeton_hopper_a_payer);				//adress, value
			Cmd_D_Plaq = 0;

		}
		
	}

	//interupt du timer0	
	if (T0IE && T0IF) {
		T0IF = 0;
		TMR0 = Reload_Timer0;
		pause = 0;
		
		if (flag == 1) {
			Cmd_D_Plaq = 1;
			eeprom_write(0,0);
			eeprom_write(1,0);
			eeprom_write(2,0);
			Cmd_D_Plaq = 0;
			flag  = 0;
		}
	}

	//interupt sur TX
	if (TXIE && TXIF) {

		send_cctalk_byte_num ++;
		buffer_timer = (send_cctalk_buffer_lenght - 1);
		if (send_cctalk_byte_num == buffer_timer) {
			TXIE = 0;
		}
		TXREG = tbl_send_cctalk_word [send_cctalk_byte_num];

	}

	//interupt sur RX
	if (RCIE && RCIF) {
		
		Rx = RCREG;

		switch (received_cctalk_byte_num) {
		
		 	case 0:
				received_Dest_Addr = Rx;
				received_calculated_checksum = Rx;
				received_cctalk_byte_num ++;
			break;
		
		 	case 1:
				received_Nbr_Datas_Bytes = Rx;
				received_calculated_checksum += Rx;
				received_cctalk_byte_num ++;
			break;
		
		 	case 2:
				received_Source_Addr = Rx;
				received_calculated_checksum += Rx;
				received_cctalk_byte_num ++;
			break;
		
		 	case 3:
				received_Header = Rx;
				received_calculated_checksum += Rx;
				received_cctalk_byte_num ++;
			break;
		
			default :
				if (received_cctalk_byte_num == received_Nbr_Datas_Bytes + 4) {
			 		received_Check_Sum = Rx;
					received_calculated_checksum += Rx;						
					received_cctalk_byte_num = 0;
		
					if (received_calculated_checksum == 0){
						//pas d'erreur de check sum
						if (received_Dest_Addr == my_addr){
							data_received = True;
						}
					}
					else {
					 	//gestion erreur check sum
					}
				}
				else {
					tbl_received_cctalk_data [received_cctalk_byte_num - 4] = Rx;
					received_calculated_checksum += Rx;
					received_cctalk_byte_num ++;
				}
			break;
		}
	}	
}