#include "declare.h"
__EEPROM_DATA(0, 0, 0, 0, 0, 0, 0, 0);


void main (void) {
unsigned char i;
unsigned char eeprom_0;
unsigned char eeprom_1;
unsigned char eeprom_2;

	init_pic ();
	init_soft ();

	for (i=0;i<150;i++) {
		_delay(100000);
	}

	eeprom_0 = eeprom_read(0);
	eeprom_1 = eeprom_read(1);
	eeprom_2 = eeprom_read(2);

	credit_en_cent = (eeprom_1 + (eeprom_0 * 256));
	nbr_jeton_hopper_impayer = eeprom_2;

	lecture_adresse_carte ();

	if ((eeprom_0 != 0) || (eeprom_1 != 0) || (eeprom_2 != 0)) {
		flag = 1;
	}

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	//the next ligne of code (eeprom_write(0,0)) cause the error, 
	//but if there are no code using eeprom_write (x,x) in the interupt.c file, 
	//there is no error.
	//I have see that I can use eeprom_write(x,x) fonction only in interupt or only in other
	//source file.

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	eeprom_write(0,0);

	//!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	
	C1IE = 1;			//enable interupt C1
	GIE = 1;	//autoris tous les unmasked interupt


	while (1) {

		if (data_received == True) {
			if (delay_before_response == False) {
				delay_before_response = True;
			}
			else {
				data_received = False;
				delay_before_response = False;

				switch (received_Header) {

					case Hd_Simple_poll:
						i = 0;
						load_cctalk_word (received_Source_Addr,i,my_addr,Hd_ACK);
					break;

					
					case Hd_Request_money_status_and_buffered_credit:
						i = 0;
						tbl_send_cctalk_data [i++] = credit_event_counter;
						tbl_send_cctalk_data [i++] = credit_en_cent / 256;
						tbl_send_cctalk_data [i++] = credit_en_cent % 256;
						tbl_send_cctalk_data [i++] = nbr_jeton_hopper_a_payer;
						tbl_send_cctalk_data [i++] = nbr_jeton_hopper_impayer;
						tbl_send_cctalk_data [i++] = 0;
						tbl_send_cctalk_data [i++] = 0;
						load_cctalk_word (received_Source_Addr,i,my_addr,Hd_ACK);

						credit_en_cent_not_yet_read = 0;
						save_flag_credit = 0;
					break;

					case Hd_Dispense_hopper_coins:
						if (tbl_received_cctalk_data [0] == 165) {
							nbr_jeton_hopper_a_payer = tbl_received_cctalk_data [1];
							hopper_event_counter ++;
							i = 0;
							tbl_send_cctalk_data [i++] = hopper_event_counter;
							load_cctalk_word (received_Source_Addr,i,my_addr,Hd_ACK);
						}
					break;
				}
			}
		}
		
		lecture_SR3 ();
		lecture_GBA ();

		gestion_hopper ();

		timing_programme ();
	}
}